<?php
defined( 'ABSPATH' ) or die( 'No ABSPATH!' );
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 DEFINES

 plugin_dir_path( __FILE__ ) );	// plugin_dir_url( __FILE__ )
 version is in genolve-toolkit.php
 
 GENOLVE_JS_URL  -  where genolve js files are loaded from
 GENOLVE_ACTION_URL  - genolve ajax submit url
*/
define( 'GENOLVE_MANAGE_GROUP', 'genolve-manage-group');
define( 'GENOLVE_DASHBOARD_GROUP', 'genolve-dashboard-group');
/* TEST   
define( 'GENOLVE_ACTION_URL',  'http://localhost/widget/');
define( 'GENOLVE_JS_URL',      'http://localhost/widget/js/' );
define( 'GENOLVE_VER',      '' );
*/

/* PRODUCTION  also change version in genolve-toolkit.php,eloop and readme.txt  */
define( 'GENOLVE_ACTION_URL',  'https://www.genolve.com/');		
define( 'GENOLVE_JS_URL',      'https://www.genolve.com/js/' );
define( 'GENOLVE_VER',         '-2.0.4' );

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_addHeaderCode -admin init functions; register options, Load css sheet for the main WordPress pages
*/
function genolve_addHeaderCode() {
	// REGISTER
	genolve_register_options();

	$user = wp_get_current_user();
	/* for more than one role
	$allowed_roles = array('editor', 'administrator', 'author');
	if( array_intersect($allowed_roles, $user->roles ) )
	*/
	wp_enqueue_script('jquery');
	$genolveO=array();
	// icons enabled in admin area
	if( get_option('genolve_enabled')=="TRUE" ){	
		//jquery-ui-core
		wp_enqueue_script('jquery-ui-core'); 
		wp_enqueue_script('jquery-ui-draggable');
   	wp_enqueue_script('jquery-ui-droppable');
		wp_enqueue_script('jquery-ui-resizable');
		// need offsite styles
		// LOCAL to plugin
		wp_enqueue_style('genolve-style', GENOLVE_PLUGIN_DIR.'css/genolve-style.css');		
		if(is_admin() ){ //  run on admin pages
			// old args, __FILE__, '' , 'all'
			wp_enqueue_script('genolve_scripts', GENOLVE_PLUGIN_DIR.'js/genolve-scripts.js',10);
			//wp_localize_script('genolve_scripts',    'genolve_enabled', array(get_option("genolve_enabled"))  );	
			}
		else { // dont run on admin pages
			//                       TAG              PATH                                            dependency   VER   PUTinFOOTER
			wp_register_script('genolve_getsvg', GENOLVE_PLUGIN_DIR.'js/genolve-getsvg.js' );
			//                       TAG              PATH                                            dependency   VER  
			//wp_enqueue_script('genolve_getsvg', plugins_url('js/genolve-getsvg.js', __FILE__), __FILE__, '' , 'all'); 
			wp_enqueue_script('genolve_getsvg');
			wp_register_script('genolve_scroll', GENOLVE_PLUGIN_DIR.'js/genolve-scroll.js' );
			wp_enqueue_script('genolve_scroll');
			wp_register_script('genolve_sound', GENOLVE_PLUGIN_DIR.'js/genolve-sound.js' );
			wp_enqueue_script('genolve_sound');
			wp_register_script('genolve_howler', GENOLVE_PLUGIN_DIR.'js/howler.min.js' );
			wp_enqueue_script('genolve_howler');
			wp_register_script('genolve_snap', GENOLVE_PLUGIN_DIR.'js/snap-0.5.1.js' );
			wp_enqueue_script('genolve_snap');
			}
		// run admin and site if user can edit posts
		if(  current_user_can('edit_posts')  ){
			// COLOR SELECTOR for dashboard
				//add_action( 'admin_enqueue_scripts', 'mw_enqueue_color_picker' );
				//function mw_enqueue_color_picker( $hook_suffix ) {
    		// first check that $hook_suffix is appropriate for your admin page
    		wp_enqueue_style( 'wp-color-picker' );
    		//wp_enqueue_script( 'genolve-color-picker', plugins_url('my-script.js', __FILE__ ), array( 'wp-color-picker' ), false, true );
				//wp_enqueue_script('wp-color-picker');
				
				wp_register_script('genolve_meta', GENOLVE_PLUGIN_DIR.'js/genolve-meta.js', array( 'wp-color-picker' ) );
				wp_enqueue_script('genolve_meta');
				wp_register_script('genolve_customize', GENOLVE_PLUGIN_DIR.'js/genolve-customize.js' );
				wp_enqueue_script('genolve_customize');
				
				//BOOTSTRAP
				wp_enqueue_script('genolve_popper', GENOLVE_PLUGIN_DIR.'js/bootstrap-4-0-ns/js/popper.min.js');
				wp_enqueue_script('genolve_bootstrap', GENOLVE_PLUGIN_DIR.'js/bootstrap-4-0-ns/js/bootstrap.min.js');
				wp_enqueue_style('genolve-style-bootstrap', GENOLVE_PLUGIN_DIR.'js/bootstrap-4-0-ns/css/bootstrap-ns.css');
				wp_enqueue_style('genolve-style-openiconic', GENOLVE_PLUGIN_DIR.'js/open-iconic/font/css/open-iconic-bootstrap.css');

				}
		//localize IMG
		$genolve_img_sel_hash=array();
		$genolve_img_sel=get_option("genolve_img_sel");
		$genolve_img_val=get_option("genolve_img_val");
		$genolve_img_par=get_option("genolve_img_par");
		$looper =(gettype($genolve_img_sel)=='string')?0:count($genolve_img_sel);
		for($ii=0;$ii<$looper;$ii++){
			// remove extension .jpg .ogv .mp4
			//$genolve_img_sel_hash[ preg_replace("/(.jpg|.ogv|.mp4)$/","",$genolve_img_sel[$ii]) ]=$genolve_img_val[$ii];
			$theval = (gettype($genolve_img_val)=='array'&&count($genolve_img_val)>$ii)?$genolve_img_val[$ii]:'badtype:'.gettype($genolve_img_val).' or size:'.count($genolve_img_val);
			$thepar = (gettype($genolve_img_par)=='array'&&count($genolve_img_par)>$ii)?$genolve_img_par[$ii]:'badtype:'.gettype($genolve_img_par).' or size:'.count($genolve_img_par);
			$genolve_img_sel_hash[ preg_replace("/(.jpg|.ogv|.mp4)$/","",$genolve_img_sel[$ii]) ]=array('val'=>$theval,'par'=>$thepar);
			}
		//echo "genolve_img_sel_hash:type:".gettype($genolve_img_sel_hash)." size:".count($genolve_img_sel_hash);
		wp_localize_script('genolve_getsvg', 'genolve_img_sel_hash', count($genolve_img_sel_hash)>0?$genolve_img_sel_hash:"{}" );		// LOCALIZE IMG JS VARS
		
		//localize GENERAL
		$genolve_gen_sel_hash=array();
		$genolve_gen_sel=get_option("genolve_gen_sel");
		$genolve_gen_val=get_option("genolve_gen_val");
		$genolve_gen_par=get_option("genolve_gen_par");
		// found case where deleting from manage leaves genolve_gen_val genolve_gen_sel in DB but empty strings
		//echo "looping genolve_gen_sel type:". gettype($genolve_gen_sel)."count:".count($genolve_gen_sel)." dump:".$genolve_gen_sel." genolve_gen_val:".count($genolve_gen_val)." genolve_gen_par:".count($genolve_gen_par);
		$looper =(gettype($genolve_gen_sel)=='string')?0:count($genolve_gen_sel);
		for($ii=0;$ii<$looper;$ii++){
			//$genolve_gen_sel_hash[ $genolve_gen_sel[$ii] ]=$genolve_gen_val[$ii];
			$genolve_gen_sel_hash[ $genolve_gen_sel[$ii] ]=array('val'=>$genolve_gen_val[$ii],'par'=>$genolve_gen_par[$ii]);;
			}
		wp_localize_script('genolve_getsvg', 'genolve_gen_sel_hash', count($genolve_gen_sel_hash)>0?$genolve_gen_sel_hash:"{}" );		// LOCALIZE TAG JS VARS
		
		/* JS vars getsvg customize*/
		//echo "DATA DATA DATA data:".get_option("genolve_enabled").",". get_option("genolve_membership").",". wp_get_theme()->get('Name') ;
		$genolve_ver = GENOLVE_VER;
		if($genolve_ver =='')$genolve_ver="notset";
		$genolveO=array();
		$genolveO['genolve_enabled']= get_option("genolve_enabled");	
		$genolveO['genolve_membership']= get_option("genolve_membership");
		$genolveO['wpajaxurl']= admin_url( 'admin-ajax.php' );	
		$genolveO['wptheme']= wp_get_theme()->get('Name') ;
		$genolveO['GENOLVE_VER']= $genolve_ver ;	
		$genolveO['jsbasedir']= GENOLVE_JS_URL;
		$genolveO['vv']= 'true';	
		$genolveO['genolve_color_bg']= get_option("genolve_color_bg") ?get_option("genolve_color_bg"):'none' ;
		$genolveO['genolve_color_txt']= get_option("genolve_color_txt")?get_option("genolve_color_txt"):'none' ;
		$genolveO['genolve_color_brdr']= get_option("genolve_color_brdr")?get_option("genolve_color_brdr"):'none' ;
		$genolveO['beyonce_getsvg']= wp_create_nonce( 'beyonce_getsvg' );	
		$genolveO['beyonce_customize']= wp_create_nonce( 'beyonce_customize' );	
		
		wp_localize_script('genolve_customize', 'genolveO', $genolveO);	
		wp_localize_script('genolve_getsvg', 'genolveO', $genolveO);
		/*wp_localize_script('genolve_customize', 'jsbasedir', array(GENOLVE_JS_URL) );            // LOCALIZE URL JS VARS
				wp_localize_script('genolve_getsvg', 'genolve_enabled', array(get_option("genolve_enabled")) );	
		wp_localize_script('genolve_getsvg', 'genolve_membership', array(get_option("genolve_membership")) );
		wp_localize_script('genolve_getsvg', 'wpajaxurl', array(admin_url( 'admin-ajax.php' ) ));	
		wp_localize_script('genolve_getsvg', 'wptheme', array(wp_get_theme()->get('Name') ));
		wp_localize_script('genolve_getsvg', 'beyonce_getsvg', array(wp_create_nonce( 'beyonce_getsvg' )) );
		wp_localize_script('genolve_customize', 'wpajaxurl', array(admin_url( 'admin-ajax.php' ) ));	
		wp_localize_script('genolve_customize', 'GENOLVE_VER', array($genolve_ver  ));	
		wp_localize_script('genolve_customize', 'vv', array('true' ) );	
		wp_localize_script('genolve_customize', 'genolve_color_bg', array(get_option("genolve_color_bg") ?get_option("genolve_color_bg"):'none' ));
		wp_localize_script('genolve_customize', 'genolve_color_txt', array(get_option("genolve_color_txt")?get_option("genolve_color_txt"):'none' ) );
		wp_localize_script('genolve_customize', 'genolve_color_brdr', array(get_option("genolve_color_brdr")?get_option("genolve_color_brdr"):'none' ) );
		wp_localize_script('genolve_customize', 'beyonce_customize', array(wp_create_nonce( 'beyonce_customize' ) ));	
		*/
		} // end genolve enabled
	}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
201904 shortcodes not used
 genolve_shortcodeHandler - Function to do the work of the plugin and return shortcode text

function genolve_shortcodeHandler() {
	$genolve_output = genolve_outputFunction(); //inc/output.php
	return $genolve_output;
}
*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_install- Runs on plugin install, adds all DB option keys, displays activation message
*/
function genolve_install() {
	//Populate new option fields with default values
	global $wpdb;
	$genolve_apikey = '';
	$genolve_enabled= 'TRUE';
	$genolve_version= GENOLVE_VER;
	// new  expandable tag OBJ
	$genolve_tag_options=array(
						 'tagsel1'=>'.wp-post-image',
						 'tagval1'=>'http://localhost/widget/athena/en/ZlistControl.php?CMD=GETSVG&displayformat=562_196&viewBox=0_0_573_200&projID=111&DEX=0x201804020010127638795803F6AD003E',
						 'tagsel2'=>'.footer',
						 'tagval2'=>''
				 );
	
	// Creates new database fields
	// in WP options table: option_name,option_value,autoload

	if(!get_option('genolve_apikey'))
		add_option("genolve_apikey", $genolve_apikey, '', 'yes');
	if(!get_option('genolve_version'))
		add_option("genolve_version", $genolve_version, '', 'yes');
	if(!get_option('genolve_color_bg'))
		add_option("genolve_color_bg", $genolve_color_bg="#880000", '', 'yes');
	if(!get_option('genolve_color_txt'))
		add_option("genolve_color_txt", $genolve_color_txt="#000000", '', 'yes');
	if(!get_option('genolve_color_brdr'))
		add_option("genolve_color_brdr", $genolve_color_brdr="#666666", '', 'yes');
	if(!get_option('genolve_tag_options'))
		add_option("genolve_tag_options", $genolve_tag_options, '', 'yes');// notused genolve_gen_tag
	if(!get_option('genolve_gen_sel')){
		$genolve_gen_sel=array();
		add_option("genolve_gen_sel", $genolve_gen_sel, '', 'yes');
		}
	if(!get_option('genolve_gen_val')){
		$genolve_gen_val=array();
		add_option("genolve_gen_val", $genolve_gen_val, '', 'yes');
		}
	if(!get_option('genolve_gen_par')){
		$genolve_gen_par=array();
		add_option("genolve_gen_par", $genolve_gen_par, '', 'yes');
		}
	if(!get_option('genolve_img_sel')){
		$genolve_img_sel=array();
		add_option("genolve_img_sel", $genolve_img_sel, '', 'yes');
		}
	if(!get_option('genolve_img_val')){
		$genolve_img_val=array();
		add_option("genolve_img_val", $genolve_img_val, '', 'yes');
		}
	if(!get_option('genolve_img_par')){
		$genolve_img_par=array();
		add_option("genolve_img_par", $genolve_img_par, '', 'yes');
		}
		//
	if(!get_option('genolve_enabled'))
		add_option("genolve_enabled", $genolve_enabled, '', 'yes');	
	if(!get_option('genolve_membership')){
		$genolve_membership="Basic";
		add_option("genolve_membership", $genolve_membership, '', 'yes');
		}
	if(!get_option('genolve_block_separator'))
		add_option("genolve_block_separator", 'nothing set', '', 'yes');
	// install message:
	// https://stackoverflow.com/questions/38233751/show-message-after-activating-wordpress-plugin?utm_medium=organic&utm_source=google_rich_qa&utm_campaign=google_rich_qa
	set_transient( 'genolve-transient-notice', true, 5 );
	$mydata =  genolve_proxy(
										array('faction' => "control",
										'keylist' => 'CMD,redir,param1,param2',
										'CMD' => 'STATUSUPDATE',
										'param1' => 'active',
										'param2' => wp_get_theme()->get('Name'),
										'beyonce_skip' => true,
										'redir' => 'JSON') 
										);
	} // end install
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_register_options - register custom options
 https://codex.wordpress.org/Creating_Options_Pages
*/
function genolve_register_options() { // whitelist options
	//MANAGE
	$mygroup = GENOLVE_MANAGE_GROUP;
	register_setting( $mygroup, 'genolve_gen_sel' );
	register_setting( $mygroup, 'genolve_gen_val' );
	register_setting( $mygroup, 'genolve_gen_par' );
	register_setting( $mygroup, 'genolve_img_sel' );
	register_setting( $mygroup, 'genolve_img_val' );
	register_setting( $mygroup, 'genolve_img_par' );
	
	//DASHBOARD
	$mygroup = GENOLVE_DASHBOARD_GROUP;
	register_setting( $mygroup, 'genolve_apikey' );
	register_setting( $mygroup, 'genolve_color_bg' );
	register_setting( $mygroup, 'genolve_color_txt' );
	register_setting( $mygroup, 'genolve_color_brdr' );
	register_setting( $mygroup, 'genolve_enabled' );
	
	//RESERVED or code-only options
	//register_setting( $mygroup, 'genolve_version' );
	//register_setting( $mygroup, 'genolve_params' );
	//register_setting( $mygroup, 'genolve_tag_options' );
	//register_setting( $mygroup, 'genolve_membership' );
	//register_setting( $mygroup, 'genolve_block_separator' );

}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_deactivate -Runs on deactivation stops all updates
*/
function genolve_deactivate() {
	$mydata =  genolve_proxy(
										array('faction' => "control",
										'keylist' => 'CMD,redir,param1,param2',
										'CMD' => 'STATUSUPDATE',
										'param1' => 'inactive',
										'param2' => wp_get_theme()->get('Name'),
										'beyonce_skip' => true,
										'redir' => 'JSON') 
										);
	// stop any email messages
	} // end deactivate
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_remove -Runs on uninstall and deletes the database fields
*/
function genolve_remove() {
	$mydata =  genolve_proxy(
										array('faction' => "control",
										'keylist' => 'CMD,redir,param1,param2',
										'CMD' => 'STATUSUPDATE',
										'param1' => 'deleted',
										'param2' => wp_get_theme()->get('Name'),
										'beyonce_skip' => true,
										'redir' => 'JSON') 
										);
	delete_option('genolve_apikey');
	delete_option('genolve_version');
	delete_option('genolve_color_bg');
	delete_option('genolve_color_txt');
	delete_option('genolve_color_brdr');
	delete_option('genolve_tag_options');
	delete_option('genolve_gen_sel');
	delete_option('genolve_gen_val');
	delete_option('genolve_gen_par');
	delete_option('genolve_img_sel');
	delete_option('genolve_img_val');
	delete_option('genolve_img_par');
	delete_option('genolve_enabled');
	delete_option('genolve_membership');
	delete_option('genolve_block_separator');
	} // end remove
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
  genolve_registerWidget - Register the widget
*/
function genolve_registerWidget() {
	register_widget('genolve_widget');
	}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	genolve_userbasic - user agreed to show genolve link 
*/
function genolve_userbasic(){
	if(get_option("genolve_membership")=="BasicPlus" &&  ! is_admin())//get_option("genolve_membership")
		echo '<a class="gnlv-logo-lr" id="genolve-powered-by" href="https://www.genolve.com" target="_blank">animations by genolve</a>';
	}
//  AJAX                  AJAX               AJAX                HANDLERS BELOW
//  AJAX                  AJAX               AJAX                HANDLERS BELOW
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	genolve_send_json - send ajax response
*/
function genolve_send_json( $response ) {
		//@header( 'Content-Type: application/json; charset=utf-8'  );
		//20180524 the BADREQUSTBUG  remove: charset=utf-8   > chrome still bad
    //@header( 'Content-Type: application/json; charset=utf-8'  );
    echo wp_json_encode( $response );
    wp_die();
		}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	genolve_send_json_error - send ajax error message
*/
function genolve_send_json_error( $msg ) {
		$jsonRespA=array('result' => 'error', 
            'message' => $msg, 
            'success' => false );
		genolve_send_json( $jsonRespA );
		}

// adding a new one? dont forget the add_action( 'wp_ajax_
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_proxy - wp_ajax post : curl forward _POST to genolve and echo response
                         OR direct call by setting arg postO
  expecting POSTvars faction - the forward action
                     keylist - the list of vars to forward
*/
function genolve_proxy( $postO=null ){
	/*
   if( !class_exists( 'WP_Http' ) )
        include_once( ABSPATH . WPINC. '/class-http.php' );
  $request = new WP_Http;
  $result = $request->request( $faction, array( 'method' => 'POST', 'body' => $jsonRespA) );
	*/
	$mode  = (($postO==null)?"echo":"return");
	if($mode=="echo")
		$postO = $_POST;
		
	$faction = sanitize_text_field($postO['faction']);
	if($faction=="track")
		$faction=GENOLVE_ACTION_URL.'athena/en/track.php'; 
	else if($faction=="control")
		$faction=GENOLVE_ACTION_URL.'athena/en/ZlistControl.php'; 
	$keylist = sanitize_text_field($postO['keylist']);
	$keyA = preg_split("/,/",$keylist);
	$apikey = get_option('genolve_apikey');
	$jsonRespA=array('apikey' => $apikey); 
	for($ii=0;$ii<count($keyA);$ii++){
		if(preg_match("/^beyonce/",$keyA[$ii]) )
			$mybeyonce=$keyA[$ii];
		$jsonRespA[ $keyA[$ii] ]=$postO[ $keyA[$ii] ];
		}
	//$retval=check_ajax_referer('beyonce','security',true);
	if($postO['beyonce_skip']==true)
		$mybeyonce="skip";//skip for PHP initiated calls
	else{
		$retval=check_ajax_referer($mybeyonce,$mybeyonce,false);
		if(  ($mybeyonce=="beyonce_customize" && !current_user_can('edit_posts')) || !$retval )
			genolve_send_json_error("Error: user lacks permissions:".current_user_can('edit_posts')." or nonce fail:".$retval);
		}

	$result = wp_remote_post( $faction, array(
																			'method' => 'POST',
																			'timeout' => 45,
																			'redirection' => 5,
																			'httpversion' => '1.0',
																			'blocking' => true,
																			'headers' => array(),
																			'cookies' => array(),
																			'body' => $jsonRespA
																				) );
// result.headers 
// result.body
// result.response.[code,message]
// result.cookies
////echo "body:".$result['body']." response:".$result['response'];
	if ( is_wp_error( $result ) ) {// errors
			genolve_send_json_error( $result->get_error_message() );
		}
	else { //good2go
		$thebody = $result['body'];
		/* debug
		genolve_send_json_error("genolve_proxy: mode:".$mode." got body type:".gettype($thebody) ." body dump:".$thebody);		
		genolve_send_json_error("genolve_proxy: got type:".gettype($thebody) ." this proves the bad request NOT CAUSED by svg because there is no svg");
		yes, always expect type string
		*/
		if(gettype($thebody)=="string" && preg_match("/^{/",$thebody) ){ // should be already encoded JSON!!!!
			if($mybeyonce!="skip")
				$thebody = preg_replace("/^{/",'{"'.$mybeyonce.'":"'.wp_create_nonce($mybeyonce).'",',$thebody);
			// special processing
			$thebodyJ=json_decode($thebody,true); 
			// remove true for property_exists($thebodyJ,'newapikey') 
			if(!empty($thebodyJ) && array_key_exists('newapikey',$thebodyJ) && $thebodyJ['newapikey'] !=null )// set it
				if( get_option("genolve_apikey")==null )// set it
					update_option("genolve_apikey", sanitize_text_field($thebodyJ['newapikey'] ) );
			if(!empty($thebodyJ) && array_key_exists('errorcode',$thebodyJ) && $thebodyJ['errorcode']=='ER_APIKEY')
				if($mode=="echo")
					$thebody = preg_replace("/^{/",'{"admin_email":"'.get_bloginfo('admin_email').'","wptheme":"'.wp_get_theme()->get('Name').'",',$thebody);
				else {//add option for autoregister
					$thebodyJ['admin_email']=get_bloginfo('admin_email');
					$thebodyJ['wptheme']=wp_get_theme()->get('Name');
				}
				
		 	if($mode=="echo") // _POST mode
				echo  $thebody ; 
			else 
				return $thebodyJ;
    	wp_die();
			}
		// show an error
		genolve_send_json_error("genolve_proxy: The server did not return expected type, got:".gettype($thebody)." first 100 chars:".substr($thebody,0,100));
		}// end good2go
	// 
	// seeing BAD REQUEST bug ?
	// 
	// https://stackoverflow.com/questions/20664341/bad-request-error-when-posting-data-using-jquery-in-ie-only?utm_medium=organic&utm_source=google_rich_qa&utm_campaign=google_rich_qa
	//causes error header('Content-Type: application/json'); // for jsonp application/javascript
	//
	//echo json_encode( $jsonRespA );	
	//wp_die();
	} // end proxy
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_setOpt - wp_ajax post : Set genolve block options like genolve_block_separator
 called by: eloop
*/

function genolve_setOpt(){
	$retval=check_ajax_referer('beyonce_customize','beyonce_customize',false);
	if(  !current_user_can('edit_posts') || !$retval )
		genolve_send_json_error("Error: user lacks permissions:".current_user_can('edit_posts')." or nonce fail:".$retval);
	$thesvg = sanitize_text_field($_POST['thesvg']);
	$theopt = sanitize_key($_POST['theopt']);
	$themem = sanitize_text_field($_POST['themem']);
	update_option($theopt,$thesvg);
	$jsonRespA=array('result' => 'success', 
								'message' => 'Selections saved!', 
								'success' => true,
								'beyonce_customize' => wp_create_nonce( 'beyonce_customize' )  );
	genolve_send_json( $jsonRespA );	
	}// end genolve_setOpt
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_add2list - wp_ajax post : add on to genolve_gen_sel
  expecting POSTvars thesel,thesvg,themem
*/
function genolve_add2list(){
	$retval=check_ajax_referer('beyonce_customize','beyonce_customize',false);
	if(  !current_user_can('edit_posts') || !$retval )
		genolve_send_json_error("Error: user lacks permissions:".current_user_can('edit_posts')." or nonce fail:".$retval);
	$thesel = sanitize_text_field($_POST['thesel']);
	$thesvg = sanitize_text_field($_POST['thesvg']);  // base64 looks like text: data:image/svg+xml;base64,PHN2Z
	$thepar = sanitize_text_field($_POST['thepar']);
	$themem = sanitize_text_field($_POST['themem']);
	// get current list
	$genolve_gen_sel=get_option("genolve_gen_sel");
	$genolve_gen_val=get_option("genolve_gen_val");
	$genolve_gen_par=get_option("genolve_gen_par");
	if (gettype($genolve_gen_sel) != "array") {
		$genolve_gen_sel=array();
		$genolve_gen_val=array();
		$genolve_gen_par=array();
		}
	// UPDATE
	$isnew=true;
	for($ii=0;$ii<count($genolve_gen_sel);$ii++){
		if($thesel == $genolve_gen_sel[$ii]){
			$isnew=false;
			$genolve_gen_val[$ii]=$thesvg;
			$genolve_gen_par[$ii]=$thepar;
			continue;
			}
		}
	// NEW
	if($isnew){
		array_push($genolve_gen_sel,$thesel);
		array_push($genolve_gen_val,$thesvg);
		array_push($genolve_gen_par,$thepar);
		}
	update_option("genolve_gen_sel",$genolve_gen_sel);
	update_option("genolve_gen_val",$genolve_gen_val);
	update_option("genolve_gen_par",$genolve_gen_par);
	update_option("genolve_membership",$themem);
	$jsonRespA=array('result' => 'success', 
								'message' => 'Selections saved!', 
								'success' => true,
								'beyonce_customize' => wp_create_nonce( 'beyonce_customize' )  );
	genolve_send_json( $jsonRespA );	
	} // end add2list
	
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_savefile - wp_ajax post : save remote genolve image/video and store in Media
 javascript side:jqsubmit2.sharetwitter
 example input:
action: genolve_savefile
thelink: https://genolve-video.s3.us-east-2.amazonaws.com/2020/08/summer-breeze.mp4
thepost: 
thedesc: summer breeze
beyonce_customize: e1b0d266e6
*/
function genolve_savefile($postO=null) {
		 if($postO==null)
				$postO = $_POST;
		 if ( !function_exists('media_handle_upload') ) {
        require_once(ABSPATH . "wp-admin" . '/includes/image.php');
        require_once(ABSPATH . "wp-admin" . '/includes/file.php');
        require_once(ABSPATH . "wp-admin" . '/includes/media.php');
    		}
		$retval  = check_ajax_referer('beyonce_customize','beyonce_customize',false);
		if(  !current_user_can('edit_posts') || !$retval )
			genolve_send_json_error("Error: user lacks permissions:".current_user_can('edit_posts')." or nonce fail:".$retval);
		$url     = esc_url_raw($postO['thelink']);	
		$pid     = intval($postO['thepost']);	
		$desc    = sanitize_text_field($postO['thedesc']);
		$themode = sanitize_key($postO['themode']);
		$theslot = sanitize_text_field($postO['theslot']);
		$thekey  = sanitize_key($postO['thekey']);
		
		if($desc==null)$desc="";	
		$origurl = $url;
		//20200913 if called 'justimg' respect extension
		if($themode != "justimg")
			$url = preg_replace("/(mp4|ogv)$/",'jpg',$url);

		//$url = preg_replace("/jpg$/",'svg',$url);
		// this was to test direct save of svg (not allowed)
		////$url = "https://www.genolve.com/svg/imgu/2017/06/quotes-ce8964b2-966b-448e-b09e-dc9eb7f45163.svg";
		// is this not working??    
		//                               there can be no dash in the base name
		$ext = preg_replace("/.*\./","",$url);
		$nam = preg_replace("/.*\//","",$url);//strip all path info
		$reg = '/\.'. $ext .'$/';
		
		$cod = preg_replace($reg,"",$nam); // strip the extension
		if(!preg_match("/^https:\/\/genolve-video/",$origurl) && false){//20210524 disable old mode, no more categories
			$codA = explode('-', $cod,2); //cut off category tag
			$cod = $codA[count($codA)-1];
			}
		if($themode == "justimg")
			$randname = $nam;
		else
			$randname = "genolve". date("YmdHis").".".$ext;
		
		//$validLink = $this->checkValidLink( $url );
		//check_ajax_referer()
		$validLink = false;
		if($themode == "justimg" && (preg_match("/.*(pixabay|wikimedia).*/",$url)>0)){
			$validLink = true;
			}
		else if(preg_match("/^https:\/\/www\.genolve\.com/",$url)>0 || preg_match("/static\.genolve\.com/",$url)>0 ||
			preg_match("/^https:\/\/genolve-video/",$url)>0 ){
			$validLink = true;
			}
		else {
			genolve_send_json_error("the link is bad:".$url);
			}
		////echo "\ngenolve_savefile try to save extension:".$ext. " url:".$url." validLink:".$validLink;
		if( $validLink == true ){
			$timeout = 300; //get_option( 'emu_timeout' , 300 );
			// DOWN LOAD  IMG                                 DOWN LOAD  IMG                         DOWN LOAD  IMG
			$tmp = download_url( $url , $timeout );
			// on windows, expect: C:\WINDOWS\TEMP/options-general-7af816c6-7ade-4385-d7b6-af74927229c3-bjKljh.tmp
			////echo "genolve_savefile I downloaded your stuff here:".$tmp;
			if ( is_wp_error( $tmp ) ) { // ERROR  CATCH 1
				unlink($tmp);
				genolve_send_json_error( $tmp->get_error_message() );
				}
			/* WAY to directly put in directory
			(wont see in media)
			
			 see if we have the uploads dir
			$dirO = wp_upload_dir();
			$uploads_dir = trailingslashit( $dirO['basedir'] ) . 'genolve-uploads';
			wp_mkdir_p( $uploads_dir );  // no prob to call if already exists
			
			// move instead? rename('foo/test.php', 'bar/test.php');
			$target = trailingslashit($uploads_dir).$randname;
			////echo "\ngenolve_savefile target file:".$target;
			// for a raw copy copy($tmp,$target);
			*/
			// SIDE LOAD                                   SIDE LOAD                          SIDE LOAD
			$fileA=array(
						'name' => $randname, 
					// not in codex example https://codex.wordpress.org/Function_Reference/media_handle_sideload
          //  'type' => 'image/jpeg', 
						'type' => wp_check_filetype($tmp),
            'tmp_name' => $tmp, 
            'error' => 0, //normally, this is used to store an error, should the upload fail. but since this isnt actually an instance of $_FILES we can default it to zero here
            'size' => filesize($tmp) );
			$new_post_id= ($pid==null || $pid<0)?0:$pid; // set 0 for no parent post id or simple attachment otherwise pass post id for include in post
			$media = media_handle_sideload($fileA, $new_post_id, $desc );  // <    M E D I A    S I D E     L O A D
			
			if (  is_wp_error( $media ) ) {// ERROR  CATCH 2
				unlink($tmp);
				genolve_send_json_error( $media->get_error_message() );
			} else if(empty($media) ) {		// ERROR  CATCH 3
				unlink($tmp);
				genolve_send_json_error('the function media_handle_sideload reported success but failed!');
				}
			else {  // SUCCESS    process image into MEDIA FOLDER
				unlink($tmp);
				// for a video icon i think we'd need:
				//    side load the jpg cover seperate and pass THAT in as the media
				// https://gist.github.com/zagk/000a56d9b17a853bba2c4599e37a82e2
				$data = set_post_thumbnail( $new_post_id, $media );

				$local_url = wp_get_attachment_url( $media );
				$local_fname = preg_replace("/.*\//","",$local_url);
				$dmsg .="local_fname:".$local_fname." code:".$cod;
				if($themode == "justimg")
					;//nada
				else{
					// UPDATE IMAGE ARRAY
					// get current list
					$genolve_img_sel=get_option("genolve_img_sel");
					$genolve_img_val=get_option("genolve_img_val");
					$genolve_img_par=get_option("genolve_img_par");
					if (gettype($genolve_img_sel) != "array") {
						$genolve_img_sel=array();
						$genolve_img_val=array();
						$genolve_img_par=array();
						}
					// WILL ALWAYS be NEW
					array_push($genolve_img_sel,$local_fname); // image name
					array_push($genolve_img_val,$cod); // the "code"
					array_push($genolve_img_par,''); // blank
					$dmsg .=" genolve_img_sel type:".gettype($genolve_img_sel)." val:".implode(",",$genolve_img_sel)." genolve_img_val:".implode(",",$genolve_img_val);
					update_option("genolve_img_sel",$genolve_img_sel);
					update_option("genolve_img_val",$genolve_img_val);
					update_option("genolve_img_par",$genolve_img_par);
					}
				// PREPATE JSON MSG
				$jsonRespA=array('result' => 'success', 
								'message' => 'Your file has been placed here:'.$local_url.'<br><img src="'.$local_url.'" width="300px" height="auto" />', 
								'localurl' => $local_url,
								'origurl' => $origurl,
								'slot' => $theslot,
								'key' => $thekey,
								'debug' => $dmsg,
								'success' => true,
								'beyonce_customize' => wp_create_nonce( 'beyonce_customize' )   );
				echo json_encode( $jsonRespA );	
				wp_die();
			}
			// END SIDE LOAD                                   SIDE LOAD                          SIDE LOAD
			
			}
		wp_die();
	}// end genolve_savefile
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 genolve_loadCSS -Function to register and then enqueue CSS and fonts on the admin settings page
 called by settings->genolve_adminMenu
*/
function genolve_loadCSS() {
	wp_enqueue_style('genolve_settingsCSS', GENOLVE_PLUGIN_DIR.'css/genolve-settings.css', __FILE__, '', 'all');	
	add_action('admin_init', 'genolve_addHeaderCode');
	}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* START debug prints, production: comment out 
define('temp_file', ABSPATH.'/_temp_out.txt' );

add_action("activated_plugin", "activation_handler1");
function activation_handler1(){
    $cont = ob_get_contents();
    if(!empty($cont)) file_put_contents(temp_file, $cont );
}

add_action( "pre_current_active_plugins", "pre_output1" );
function pre_output1($action){
    if(is_admin() && file_exists(temp_file))
    {
        $cont= file_get_contents(temp_file);
        if(!empty($cont))
        {
            echo '<div class="error"> Error Message:' . $cont . '</div>';
            @unlink(temp_file);
        }
    }
}
 END debug prints, production: comment out */
?>
